       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPLAWRD.
      **** rel 7.2
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           SELECT LETINT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-LET.
      *
           SELECT FILEFX ASSIGN TO NOMEFILE
                  ORGANIZATION SEQUENTIAL.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'grilet'.
       FD  FILEFX LABEL RECORD OMITTED DATA RECORD RF-FFX.
       01  RF-FFX.  
           05 INFO.
              10 D-TIPS    PIC X.
              10 SP01      PIC X.
              10 D-NCOP    PIC 9.
              10 SP02      PIC X.
              10 D-FAX     PIC X(30).
              10 SP03      PIC X.
      * d-totpag: e' valorizzato correttamente solo sull'ultimo record.
              10 D-TOTPAG  PIC 9.    
              10 SP04      PIC X.
              10 D-FLGS    PIC X.
              10 SP05      PIC X.
              10 D-IDDOC   PIC X(50).
              10 SP06      PIC X.
           05 TESTA.
      * record A
              10 D-LETA-CDF    PIC X(5).
              10 SP07      PIC X.
              10 D-LETA-TFO    PIC Z9.
              10 SP08      PIC X.
              10 D-LETA-CFFO   PIC X(16).
              10 SP09      PIC X.
      * record B
              10 D-LETB-CFDI   PIC X(16).
              10 SP10      PIC X.
              10 D-LETB-PRMO   PIC 9(8).
              10 SP11      PIC X.
              10 D-LETB-NRPR   PIC X(25).
              10 SP12      PIC X.
              10 D-LETB-IDDI   PIC X(20).
              10 SP13      PIC X.
              10 D-LETB-PSWG   PIC X(16).
              10 SP14      PIC X.
              10 D-LETB-DICO   PIC X.
              10 SP15      PIC X.
              10 D-LETB-PROT1 PIC X(17).
              10 SP16      PIC X.
              10 D-LETB-PROT2 PIC X(6).
              10 SP17      PIC X.
              10 D-LETB-NOME   PIC X(20).
              10 SP18      PIC X.
              10 D-LETB-DENO   PIC X(60).
              10 SP19      PIC X.
              10 D-LETB-PIVA   PIC X(11).
              10 SP20      PIC X.
              10 D-LETB-CONA   PIC X(40).
              10 SP21      PIC X.
              10 D-LETB-PRNA   PIC X(2).
              10 SP22      PIC X.
              10 D-LETB-DTNAGG PIC ZZ.
              10 SP23      PIC X.
              10 D-LETB-DTNAMM PIC ZZ.
              10 SP24      PIC X.
              10 D-LETB-DTNAAA PIC ZZZZ.
              10 SP25      PIC X.
              10 D-LETB-SESS  PIC X.
              10 SP26      PIC X.
              10 D-LETB-CODF   PIC X(16).
              10 SP27      PIC X.
              10 D-LETB-CFSOC  PIC X(11).
              10 SP28      PIC X.
              10 D-LETB-CODC   PIC ZZ.
              10 SP29      PIC X.
              10 D-LETB-COGNC  PIC X(24).
              10 SP30      PIC X.
              10 D-LETB-NOMEC  PIC X(20).
              10 SP31      PIC X.
              10 D-LETB-SESSC PIC X.
              10 SP32      PIC X.
              10 D-LETB-DTNACGG  PIC ZZ.
              10 SP33      PIC X.
              10 D-LETB-DTNACMM  PIC ZZ.
              10 SP34      PIC X.
              10 D-LETB-DTNACAA  PIC ZZZZ.
              10 SP35      PIC X.
              10 D-LETB-CONAC  PIC X(40).
              10 SP36      PIC X.
              10 D-LETB-PRNAC  PIC X(2).
              10 SP37      PIC X.
              10 D-LETB-NTEL   PIC X(12).
              10 SP38      PIC X.
              10 D-LETB-EMAIL  PIC X(50).
              10 SP39      PIC X.
              10 D-LETB-CACQ   PIC X.
              10 SP40      PIC X.
              10 D-LETB-CIMP   PIC X.
              10 SP41      PIC X.
              10 D-LETB-ANNO   PIC 9(4).
              10 SP42      PIC X.
              10 D-LETB-IMPO   PIC X(13).
              10 SP71      PIC X.
              10 D-LETB-IMPOD  PIC X(2).
              10 SP43      PIC X.
              10 D-LETB-IMPC   PIC X(13).
              10 SP72      PIC X.
              10 D-LETB-IMPCD  PIC X(2).
              10 SP44      PIC X.
              10 D-LETB-DTDAGG PIC ZZ.
              10 SP45      PIC X.
              10 D-LETB-DTDAMM PIC ZZ.
              10 SP46      PIC X.
              10 D-LETB-DTDAAA PIC ZZZZ.
              10 SP47      PIC X.
              10 D-LETB-DTAGG PIC ZZ.
              10 SP48      PIC X.
              10 D-LETB-DTAMM PIC ZZ.
              10 SP49      PIC X.
              10 D-LETB-DTAAA PIC ZZZZ.
              10 SP50      PIC X.
              10 D-LETB-DESCR  PIC X(100).
              10 SP51      PIC X.
              10 D-LETB-NATTR  PIC X(16).
              10 SP52      PIC X.
              10 D-LETB-ANNOD  PIC 9(4).
              10 SP53      PIC X.
              10 D-LETB-DOGA   PIC X.
              10 SP54      PIC X.
              10 D-LETB-CFISCD PIC X(16).
              10 SP55      PIC X.
              10 D-LETB-PIVAD  PIC 9(11).
              10 SP56      PIC X.
              10 D-LETB-NOMD   PIC X(20).
              10 SP57      PIC X.
              10 D-LETB-DENOM  PIC X(60).
              10 SP58      PIC X.
              10 D-LETB-SES    PIC X.
              10 SP59      PIC X.
              10 D-LETB-TPLA1  PIC X(1).
              10 SP60      PIC X.
              10 D-LETB-TPLA2  PIC X(1).
              10 SP61      PIC X.
              10 D-LETB-CDIAP  PIC X(1).
              10 SP62      PIC X.
              10 D-LETB-EPSO   PIC X(1).
              10 SP63      PIC X.
              10 D-LETB-CINTRA PIC X(1).
              10 SP64      PIC X.
              10 D-LETB-CSANM  PIC X(1).
              10 SP65      PIC X.
              10 D-LETB-OPERAS PIC X(1).
              10 SP66      PIC X.
              10 D-LETB-OPERST PIC X(1).
              10 SP67      PIC X.
              10 D-LETB-CFISI  PIC X(16).
              10 SP68      PIC X.
              10 D-LETB-DTIMGG PIC ZZ.
              10 SP69      PIC X.
              10 D-LETB-DTIMMM PIC ZZ.
              10 SP70      PIC X.
              10 D-LETB-DTIMAA PIC ZZZZ.
           05 XTAPPO PIC XX.
      *
       WORKING-STORAGE SECTION.
           COPY 'grirel-73'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'griclfrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parab'.
           COPY 'parwo'.
           COPY 'parrm'.
           COPY 'parop'.
           COPY 'parul'.
           COPY 'parrd'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-LET PIC X(80) VALUE 'letint'.
      * parametri chiamata X"91" per scrittura corretta carattere TAB
       01  RX-91      PIC 99 COMP-X.
       01  FX-91      PIC 99 COMP-X VALUE 47.
      *
       01  SLEEPSEC     PIC 9(6).
      *
       01  COMODI.
           05 SF-AZI     PIC XX.
           05 SF-LET     PIC XX.
           05 NPAG       PIC 999.
           05 MESS       PIC X(40) VALUE SPACE.
           05 CODCLI     PIC 9(7).
           05 TIPPER     PIC 9.
           05 K          PIC 99.
           05 VETTORE-VALORI.
              10 VET-A PIC S9(11)V99 COMP-3 OCCURS 34.
           05 DATI-INTERI PIC X(1800).
           05 DATI-DIVISI REDEFINES DATI-INTERI OCCURS 75.
              10 IDE PIC X(8).
              10 VAL PIC X(16).
           05 CONT PIC 9(5).
           05 TOTPAG PIC 9(5).
           05 COMNRIG PIC 9(5).
           05 INDR       PIC 99.
           05 MAXR       PIC 99.

           05 NOMEFILE   PIC X(80).
           05 TAPPO      PIC XX    VALUE X'0D0A'.
           05 SEPAR      PIC X     VALUE X'09'.
           05 SWSTAMPA   PIC 9     VALUE ZERO.
           05 SAVPATH    PIC X(50) VALUE SPACE.
           05 COMCNT     PIC 999   VALUE ZERO.
      *
      *    COPY 'vplawrd.cpy'.
      *---------------------------------------------------------
      * Parametri CBL_CHECK_EXIST_FILE
       01  FILE-NAME          PIC X(60).
       01  FILE-DETAILS.
           05 FILE-SIZE       PIC X(8) COMP-X.
           05 FILE-DATE.
              10 F-DAY        PIC X  COMP-X.
              10 F-MONTH      PIC X  COMP-X.
              10 F-YEAR       PIC X(2) COMP-X.
           05 FILE-TIME.
              10 F-HOURS      PIC X COMP-X.
              10 F-MINUTES    PIC X COMP-X.
              10 F-SECONDS    PIC X COMP-X.
              10 F-HINDREDTHS PIC X COMP-X.
       01  STATUS-CODE        PIC X(2)   COMP-X.
      *---------------------------------------------------------
       LINKAGE SECTION.
           COPY 'parwpla'.
       PROCEDURE DIVISION USING PARWPLA PARCCD.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
           MOVE ZERO TO PCCD-ERR.

      * Inizializza
           IF PCCD-FUN = 'T' OR 'I'
              PERFORM PGM-INI THRU EX-PGM-INI
              IF SWSTAMPA = 9 GO TO CHIUDI.

      * Esegue
           IF PCCD-FUN = 'T' OR 'R'
              PERFORM PGM-RUN THRU EX-PGM-RUN.

      * Chiude
           IF PCCD-FUN = 'T' OR 'E'
              PERFORM PGM-END THRU EX-PGM-END
              GO TO CHIUDI.

           GO TO FINE.
       ERRIO.
           COPY 'errsub'.
           MOVE 9 TO PCCD-ERR.
       CHIUDI.
           CLOSE ANAAZI.
       FINE.
           EXIT PROGRAM.
      *-------------------*
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'grixxxer'.
      *------------------------------------------*
       PGM-END.
           CLOSE FILEFX.
      *
           IF SWSTAMPA = ZERO
      * Nessuna stampa word eseguita
      *       MOVE 1 TO PCCD-ERR
              GO TO EX-PGM-END.

           MOVE 'R' TO WO-FUN.
           CALL 'vrword' USING PARWO.

           IF PCCD-PATH = SPACE GO TO EX-PGM-END.

      * Attesa eliminazione file "D-" (semaforo fine salvataggio
      * file di stampa unione)
           MOVE 20 TO COMCNT. 
           PERFORM UNTIL COMCNT = ZERO OR 999
              SUBTRACT 1 FROM COMCNT

              MOVE 5 TO SLEEPSEC
              CALL 'vrsleep' USING SLEEPSEC

              MOVE NOMEFILE TO FILE-NAME
              CALL "CBL_CHECK_FILE_EXIST" USING FILE-NAME
                                                FILE-DETAILS
                                  RETURNING STATUS-CODE
              IF STATUS-CODE NOT = ZERO MOVE 999 TO COMCNT.

           IF COMCNT = 999 GO TO EX-PGM-END.

      * Timeout attesa cancellazione semaforo
           MOVE 2 TO PCCD-ERR.

       EX-PGM-END.
           EXIT.
      *------------------------------------------*
       PGM-INI.
           COPY 'strsub'.
           MOVE ZERO TO SWSTAMPA.
           MOVE SPACE TO SAVPATH.
      *
           OPEN INPUT ANAAZI.
      *
           MOVE PWPLA-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
      *
           MOVE 'I'       TO WO-FUN.
           MOVE 'intent'  TO WO-IDDOC.
           MOVE PWPLA-AZI TO WO-AZI.
           CALL 'vrword' USING PARWO.
           IF WO-ST > ZERO
              MOVE 9 TO SWSTAMPA
              GO TO EX-PGM-INI.

           MOVE 'L' TO WO-TIPRUN.
           MOVE WO-NRIGHE TO MAXR.
      *
           MOVE SPACE TO NOMEFILE.
           STRING WO-DIROUT '\d-' WO-IDDOC '.doc' DELIMITED SPACE
                                                  INTO NOMEFILE.
           OPEN OUTPUT FILEFX.
           CALL X'91' USING RX-91 FX-91 FILEFX.
       EX-PGM-INI.
           EXIT.
      *------------------------------------------*
       PGM-RUN.
           STRING PWPLA-FILE DELIMITED SPACE INTO ID-LET.
           OPEN INPUT LETINT.
           IF SF-LET NOT = ZERO
              MOVE 'FILE INESISTENTE' TO MESS
              GO TO ERRIO.
           IF SAVPATH = SPACE AND PCCD-PATH NOT = SPACE
              STRING PCCD-PATH DELIMITED SPACE
                     '\pla'
                     PWPLA-AZI
                     PWPLA-NPRT
                     '.doc'
                     DELIMITED SIZE INTO SAVPATH
              MOVE SAVPATH TO PCCD-PATH.
      *
           MOVE ZERO TO NPAG CONT.
      *
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      *
           MOVE PWPLA-NRIG TO COMNRIG.
           MOVE 1 TO TOTPAG.
           OPEN INPUT LETINT.
       INIZIO-LETTURA.
           READ LETINT AT END GO TO FINE-LETTURA.
           ADD 1 TO CONT.
           IF RF-LET(1:1) = 'A'
              PERFORM STAMPA-RECA THRU EX-STAMPA-RECA.
           IF RF-LET(1:1) = 'B' AND CONT = COMNRIG 
              PERFORM STAMPA-RECB THRU EX-STAMPA-RECB.
           GO TO INIZIO-LETTURA.
       FINE-LETTURA.
              CLOSE LETINT.
       EX-PGM-RUN.
           EXIT.
      *------------------------------------------*
       SCR-REC.
           MOVE SPACE TO D-FLGS.
           IF PCCD-FLGS = 0
              MOVE 'S' TO D-FLGS.
           MOVE PCCD-PATH TO D-IDDOC.
      *
           MOVE TAPPO TO XTAPPO.
           WRITE RF-FFX.
           MOVE 1 TO SWSTAMPA.
       EX-SCR-REC.
           EXIT.
       AZZ-REC.
           MOVE SPACE TO RF-FFX.
           PERFORM CAR-SEPARATORE THRU EX-CAR-SEPARATORE.
       EX-AZZ-REC.
           EXIT.
      *-------------------------------
       STAMPA-RECA.
      *
           PERFORM AZZ-REC THRU EX-AZZ-REC.
      *
           ADD 1 TO NPAG.
      *
           MOVE 1       TO D-NCOP.
           MOVE SPACE   TO D-FAX.
           MOVE TOTPAG  TO D-TOTPAG.    
           MOVE SPACE   TO D-TIPS.
      *
           MOVE LETA-CDF  TO D-LETA-CDF.
           MOVE LETA-TFO  TO D-LETA-TFO.
           MOVE LETA-CFFO TO D-LETA-CFFO.
       EX-STAMPA-RECA.
           EXIT.
      *-------------------------------
       STAMPA-RECB.
      *
           MOVE LETB-CFDI    TO D-LETB-CFDI.
           MOVE LETB-PRMO    TO D-LETB-PRMO.
           MOVE LETB-NRPR    TO D-LETB-NRPR.
           MOVE LETB-IDDI    TO D-LETB-IDDI.
           MOVE LETB-PSWG    TO D-LETB-PSWG.
           IF LETB-DICO = ZERO
              MOVE SPACE TO D-LETB-DICO
           ELSE
              MOVE 'X'   TO D-LETB-DICO.
           MOVE LETB-PROT1  TO D-LETB-PROT1.
           IF LETB-PROT1 = ZERO
              MOVE SPACE TO D-LETB-PROT1.
           MOVE LETB-PROT2  TO D-LETB-PROT2.
           IF LETB-PROT2 = ZERO
              MOVE SPACE TO D-LETB-PROT2.
           MOVE LETB-COGN    TO D-LETB-DENO.
           IF LETB-COGN = SPACE
              MOVE LETB-DENO    TO D-LETB-DENO.
           MOVE LETB-NOME    TO D-LETB-NOME.
           MOVE LETB-PIVA    TO D-LETB-PIVA.
           MOVE LETB-CONA    TO D-LETB-CONA.
           MOVE LETB-PRNA    TO D-LETB-PRNA.
           MOVE LETB-DTNA(1:2) TO D-LETB-DTNAGG.
           MOVE LETB-DTNA(3:2) TO D-LETB-DTNAMM.
           MOVE LETB-DTNA(5:4) TO D-LETB-DTNAAA.
           MOVE LETB-SESS TO D-LETB-SESS.
           MOVE LETB-CFISC   TO D-LETB-CODF.
           IF LETB-CFISCS = ZERO
              MOVE SPACE  TO D-LETB-CFSOC
           ELSE
              MOVE LETB-CFISCS  TO D-LETB-CFSOC.
           MOVE LETB-CODC    TO D-LETB-CODC.
           MOVE LETB-CNF     TO D-LETB-COGNC.
           MOVE LETB-NOF     TO D-LETB-NOMEC.
           MOVE LETB-SEF TO D-LETB-SESSC.
           MOVE LETB-DTNAF(1:2) TO D-LETB-DTNACGG.
           MOVE LETB-DTNAF(3:2) TO D-LETB-DTNACMM.
           MOVE LETB-DTNAF(5:4) TO D-LETB-DTNACAA.
           MOVE LETB-COFN   TO D-LETB-CONAC.
           MOVE LETB-PRFN   TO D-LETB-PRNAC.
           MOVE LETB-NTEL    TO D-LETB-NTEL.
           MOVE LETB-EMAIL   TO D-LETB-EMAIL.
           IF LETB-CACQ = ZERO
              MOVE SPACE TO D-LETB-CACQ
           ELSE
              MOVE 'X'   TO D-LETB-CACQ.
           IF LETB-CIMP = ZERO
              MOVE SPACE TO D-LETB-CIMP
           ELSE
              MOVE 'X'   TO D-LETB-CIMP.
           MOVE LETB-ANNO    TO D-LETB-ANNO.
           IF LETB-IMPO NOT = '            0,00'
              MOVE LETB-IMPO(1:13) TO D-LETB-IMPO
              MOVE LETB-IMPO(15:2) TO D-LETB-IMPOD
           ELSE
              MOVE SPACE     TO D-LETB-IMPO
              MOVE SPACE     TO D-LETB-IMPOD.
           IF LETB-IMPC NOT = '            0,00'
              MOVE LETB-IMPC(1:13) TO D-LETB-IMPC
              MOVE LETB-IMPC(15:2) TO D-LETB-IMPCD
           ELSE
              MOVE SPACE     TO D-LETB-IMPC
              MOVE SPACE     TO D-LETB-IMPCD.
      **** rel 7.2
      *    MOVE LETB-DTDA(1:2) TO D-LETB-DTDAGG.
      *    MOVE LETB-DTDA(3:2) TO D-LETB-DTDAMM.
      *    MOVE LETB-DTDA(5:4) TO D-LETB-DTDAAA.
      *    MOVE LETB-DTA(1:2) TO D-LETB-DTAGG.
      *    MOVE LETB-DTA(3:2) TO D-LETB-DTAMM.
      *    MOVE LETB-DTA(5:4) TO D-LETB-DTAAA.
           MOVE ZERO TO D-LETB-DTDAGG.
           MOVE ZERO TO D-LETB-DTDAMM.
           MOVE ZERO TO D-LETB-DTDAAA.
           MOVE ZERO TO D-LETB-DTAGG.
           MOVE ZERO TO D-LETB-DTAMM.
           MOVE ZERO TO D-LETB-DTAAA.
      ************
           MOVE LETB-DESCR    TO D-LETB-DESCR.
      **** rel 7.3
      *    MOVE LETB-NATTR    TO D-LETB-NATTR.
      *    MOVE LETB-ANNOD    TO D-LETB-ANNOD.
           MOVE SPACE         TO D-LETB-NATTR.
           MOVE ZERO          TO D-LETB-ANNOD.
      ************
           IF LETB-DOGA = ZERO
              MOVE SPACE TO D-LETB-DOGA
           ELSE
              MOVE 'X'   TO D-LETB-DOGA.
           MOVE LETB-CFISCD  TO D-LETB-CFISCD.
           MOVE LETB-PIVAD   TO D-LETB-PIVAD.
           MOVE LETB-COND    TO D-LETB-DENOM.
           IF LETB-COND = SPACE
              MOVE LETB-DENOM    TO D-LETB-DENOM.
           MOVE LETB-NOMD    TO D-LETB-NOMD.
           MOVE LETB-SES     TO D-LETB-SES.
      *
           IF LETB-TPLA = 1
              MOVE 'X'   TO D-LETB-TPLA1
              MOVE SPACE TO D-LETB-TPLA2
           ELSE
              MOVE SPACE TO D-LETB-TPLA1
              MOVE 'X'   TO D-LETB-TPLA2.
      *
           IF LETB-CDIAP = ZERO
              MOVE SPACE TO D-LETB-CDIAP
           ELSE
              MOVE 'X'   TO D-LETB-CDIAP.
      *
           IF LETB-EPSO = ZERO
              MOVE SPACE TO D-LETB-EPSO
           ELSE
              MOVE 'X'   TO D-LETB-EPSO.
      *
           IF LETB-CINTRA = ZERO
              MOVE SPACE TO D-LETB-CINTRA
           ELSE
              MOVE 'X'   TO D-LETB-CINTRA.
      *
           IF LETB-CSANM = ZERO
              MOVE SPACE TO D-LETB-CSANM
           ELSE
              MOVE 'X'   TO D-LETB-CSANM.
      *
           IF LETB-OPERAS = ZERO
              MOVE SPACE TO D-LETB-OPERAS
           ELSE
              MOVE 'X'   TO D-LETB-OPERAS.
      *
           IF LETB-OPERST = ZERO
              MOVE SPACE TO D-LETB-OPERST
           ELSE
              MOVE 'X'   TO D-LETB-OPERST.
      *
           MOVE LETB-CFISI TO D-LETB-CFISI.
           MOVE LETB-DTIM(1:2) TO D-LETB-DTIMGG.
           MOVE LETB-DTIM(3:2) TO D-LETB-DTIMMM.
           MOVE LETB-DTIM(5:4) TO D-LETB-DTIMAA.
      *
           PERFORM SCR-REC THRU EX-SCR-REC.
           MOVE ZERO TO NPAG.
       EX-STAMPA-RECB.
           EXIT.
      *-------------------------------
      *--------------*
      * carica separatore di campo
       CAR-SEPARATORE.
           MOVE SEPAR TO SP01 SP02 SP03 SP04 SP05 SP06 SP07 SP08 SP09 
                         SP10
                         SP11 SP12 SP13 SP14 SP15 SP16 SP17 SP18 SP19
                         SP20 
                         SP21 SP22 SP23 SP24 SP25 SP26 SP27 SP28 SP29
                         SP30
                         SP31 SP32 SP33 SP34 SP35 SP36 SP37 SP38 SP39
                         SP40
                         SP41 SP42 SP43 SP44 SP45 SP46 SP47 SP48 SP49
                         SP50
                         SP51 SP52 SP53 SP54 SP55 SP56 SP57 SP58 SP59
                         SP60
                         SP61 SP62 SP63 SP64 SP65 SP66 SP67 SP68 SP69
                         SP70
                         SP71 SP72
      *
           MOVE 1 TO INDR.
       EX-CAR-SEPARATORE.
           EXIT.
      *-------------------------------
