       IDENTIFICATION DIVISION.
       PROGRAM-ID. VPLA191.
      *
      * OGGETTO: CREAZIONE ARCHIVIO LETTERE D'INTENTO
      *         
      **** rel 7.2
      * ricompilato per variazione tracciato REGLIN
      **********
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'griditsl'.
           COPY 'griaazsl'.
           SELECT LETINT ASSIGN TO DISK
                  ORGANIZATION SEQUENTIAL
                  STATUS SF-LET.
      **** rel 7.2
           COPY 'grirglsl'.
      **********
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'grilet'.
           COPY 'griclf'.
           COPY 'gridit'.
           COPY 'griaaz'.
      **** rel 7.2
           COPY 'grirgl'.
      **********
       WORKING-STORAGE SECTION.
           COPY 'grirel-73'.
           COPY 'griazirk'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'griclfrk'.
           COPY 'grid02rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'prfisc'.
      *    COPY 'parpcfgr'.
      *    COPY 'parpcfgc'.
           COPY 'parmb'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-LET PIC X(80) VALUE 'letint'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-DIT PIC X(15) VALUE 'leitab'.
       01  ID-AAZ PIC X(15) VALUE 'appazi'.
      **** rel 7.2
       01  ID-RGL PIC X(15) VALUE 'reglin'.
      **********
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-LET  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-DIT  PIC XX.
           05 SF-AAZ  PIC XX.
      **** rel 7.2
           05 SF-RGL PIC XX.
      **********
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 J2      PIC 9(3)  VALUE ZERO.
           05 COMDT   PIC 9(8)  VALUE ZERO.
           05 COMDA   PIC 9(4)  VALUE ZERO.
           05 FLPAG   PIC 9      VALUE ZERO.
           05 SCRITTO PIC 9      VALUE ZERO.
           05 TESTA   PIC 9      VALUE ZERO.
           05 PATH     PIC X(80) VALUE SPACE.
           05 UFF      PIC X(20) VALUE SPACE.
           05 NRECB  PIC 9(9)  VALUE ZERO.
           05 COMIMPO PIC ZZZZZZZZZZZZ9,99  VALUE ZERO.
           05 COMIMPC PIC ZZZZZZZZZZZZ9,99  VALUE ZERO.
      **** rel 7.2
           05 COM-DTIMP PIC 9(5)  VALUE ZERO.
      *********

           05 CODICE3.
              10 MAS3   PIC 99.
              10 COD3   PIC 9(5).
           05 CODICE.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
           05 CODICE2.
              10 MAS2  PIC 99.
              10 COD2  PIC 9(5).

           05 SAV-PIVA  PIC 9(11).
           05 SAV-PRT   PIC 9(4).
           05 SAV-PRG   PIC 9(4).


           05 MODELLO.
              10 MOD PIC X(2) VALUE 'IV'.
              10 LET PIC X    VALUE 'I'.
              10 ANM PIC 9(2) VALUE 15.
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC  X(36).      
      *                                                     
           05 IF-DICO      PIC  9.      
           05 IF-PROT1     PIC  9(17).      
           05 IF-PROT2     PIC  9(6).      
           05 IF-DOGA      PIC  9.      
           05 IF-COD-1     PIC  9(5).       
           05 IF-COD-2     PIC  9(5).       
           05 IF-COD       PIC  9(5).       
           05 IF-NPRT      PIC  9(4).       
           05 IF-ANNO      PIC  9(4).       
      **** rel 7.2
           05 IF-DTIMP     PIC  9(6).       
      *********
      *                                                      
           05 IF-DESCR-1   PIC  X(100).      
           05 IF-TPDIC     PIC  9(1).       
           05 IF-IMPOR     PIC  9(11)V99.
           05 IF-PERG1     PIC  9(2).       
           05 IF-PERM1     PIC  9(2).       
           05 IF-PERG2     PIC  9(2).       
           05 IF-PERM2     PIC  9(2).       
      *
           05 IF-FILE      PIC  X(80).      
      **** rel 7.2
           05 IF-NPRT2     PIC  9(4).       
      **********
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dcllet'.
           COPY 'dclclf'.
           COPY 'dcldit'.
           COPY 'dclaaz'.
      **** rel 7.2
           COPY 'dclrgl'.
      **********
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'vpla191: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABELL.
           CLOSE LETINT.
           CLOSE ANACLF.
           CLOSE LEITAB.
           CLOSE APPAZI.
      **** rel 7.2
           CLOSE REGLIN.
      **********
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'griditer'.
           COPY 'griaazer'.
      **** rel 7.2
           COPY 'grirgler'.
      **********
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           OPEN I-O TABELL.
           OPEN INPUT ANACLF.
      **** rel 7.2
      *    OPEN INPUT LEITAB.
           OPEN I-O LEITAB.
      **********
           OPEN INPUT APPAZI.
      **** rel 7.2
           OPEN I-O REGLIN.
      **********
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID KEY 
             PERFORM INVK-TAB GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MFOR TO MAS MAS2 MAS3.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID KEY PERFORM INVK-AZI
                                               GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE ZERO    TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-UFF TO UFF.
           MOVE '1' TO T25-PRG
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
      *
           MOVE KAZ-COD TO KAAZ-COD.
           READ APPAZI INVALID
                       MOVE SPACE TO AAZ-RGSOC AAZ-CNA AAZ-PNA
                                     AAZ-SES
                       MOVE ZERO TO AAZ-DNA.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE ZERO TO COD COD2.

           MOVE ZERO  TO IF-DICO.
           MOVE ZERO  TO IF-PROT1.
           MOVE ZERO  TO IF-PROT2.
           MOVE ZERO  TO IF-DOGA.
           MOVE ZERO  TO IF-COD.
           MOVE ZERO  TO IF-COD-1.
           MOVE 99999 TO IF-COD-2.
           MOVE ZERO  TO IF-NPRT.
           MOVE ZERO  TO IF-NPRT2.
           MOVE ZERO  TO IF-ANNO.
           MOVE SPACE TO IF-DESCR-1.
           MOVE ZERO  TO IF-IMPOR.
           MOVE ZERO  TO IF-PERG1.
           MOVE ZERO  TO IF-PERM1.
           MOVE ZERO  TO IF-PERG2.
           MOVE ZERO  TO IF-PERM2.
      **** rel 7.2
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO IF-DTIMP.
           MOVE AA9 TO GG9.
           MOVE IF-DTIMP TO AA9.
           MOVE GGMMAA TO IF-DTIMP.
      *********

           MOVE AZRGSOC TO IF-AZI-D.
           MOVE 1 TO IF-TPDIC.

           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.

           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE ZERO    TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
           MOVE T25-UFF TO UFF.
           MOVE '1' TO T25-PRG
           MOVE T25-KEYID TO KEYTB.
           READ TABELL INTO REKT25 INVALID 
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKT25.
      *    MOVE T25-PRT TO IF-NPRT SAV-PRT.
      *    ADD 1 TO SAV-PRT.
      *
           MOVE AA9 TO AA4.
           CALL 'ranno4' USING AA4.
           MOVE AA4 TO IF-ANNO.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
      *
      **** rel 7.2
           MOVE D02-NFILE TO SAV-PRG.
           ADD  1         TO SAV-PRG.
      **********
           MOVE AZI-PIVA TO SAV-PIVA.
           MOVE SPACE TO ID-LET.
           STRING D02-PATHECF  DELIMITED SPACE
                  SAV-PIVA     DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  IF-ANNO(3:2) DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  SAV-PRG      DELIMITED SPACE
                  '_ivi15'     DELIMITED SIZE INTO ID-LET.
           MOVE ID-LET TO IF-FILE.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-DICO.
           MOVE 'IF-DICO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT1.
           IF IF-DICO = ZERO
              MOVE ZERO TO IF-PROT1 IF-PROT2.
       E-DICO.
      *
       V-PROT1.
           MOVE 'IF-PROT1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT1.
           IF IF-DICO NOT = ZERO
              IF IF-PROT1 = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR. 
       E-PROT1.
      *
       V-PROT2.
           MOVE 'IF-PROT2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PROT2.
           IF IF-DICO NOT = ZERO
              IF IF-PROT2 = ZERO
                 PERFORM ERR-ZERO
                 GO TO V-ERROR. 
       E-PROT2.
      *
       V-DOGA.
           MOVE 'IF-DOGA' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DOGA.
           IF IF-DOGA = 1
              MOVE ZERO TO IF-COD-1 IF-COD-2
           ELSE
              MOVE ZERO TO IF-COD.
       E-DOGA.
      *
       V-COD.
           MOVE 'IF-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD.
           IF IF-DOGA = ZERO GO TO E-COD.
           IF IF-COD = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE IF-COD TO COD3.
           MOVE KAZ-COD TO KCF-AZI.
           MOVE CODICE3 TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
           IF CLF-13IVA NOT = 3
              PERFORM ERR-DINC
              GO TO V-ERROR.
       E-COD.

       V-COD-1.
           MOVE 'IF-COD-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-1.
           IF IF-DOGA = 1     GO TO E-COD-1.
           IF IF-COD-1 = ZERO GO TO E-COD-1.
           MOVE IF-COD-1 TO COD.
       E-COD-1.
      *
       V-COD-2.
           MOVE 'IF-COD-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD-2.
           IF IF-DOGA = 1 GO TO E-COD-2.
           IF IF-COD-1 > IF-COD-2
              PERFORM ERR-DINC
              GO TO V-ERROR.
           MOVE IF-COD-2 TO COD2.
           IF IF-DICO = 1
              IF IF-COD-1 NOT = IF-COD-2
                 MOVE 'E'' possibile selezionare un solo'
                      TO F-MES1
                 MOVE 'fornitore' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO V-ERROR.
       E-COD-2.
      *
       V-ANNO.
           MOVE 'IF-ANNO' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ANNO.
           CALL 'ranno4' USING IF-ANNO.
           IF IF-ANNO < 1990
              PERFORM ERR-DINC
              GO TO V-ERROR.
           MOVE AZI-PIVA TO SAV-PIVA.
           MOVE SPACE TO ID-LET.
      *    COMPUTE SAV-PRT = IF-NPRT + 1.
           STRING D02-PATHECF DELIMITED SPACE
                  SAV-PIVA    DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  IF-ANNO(3:2) DELIMITED SPACE
                  '_'          DELIMITED SPACE
                  SAV-PRG     DELIMITED SPACE
                  '_ivi15'    DELIMITED SIZE INTO ID-LET.
           MOVE ID-LET TO IF-FILE.
       E-ANNO.
      *
      **** rel 7.2
       V-DTIMP.
           MOVE 'IF-DTIMP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIMP.
           IF IF-DTIMP = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
      *
           MOVE IF-DTIMP TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO COM-DTIMP.
       E-DTIMP.
      *
      *********
       V-TPDIC.
           MOVE 'IF-TPDIC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPDIC.
      *    IF IF-TPDIC = 1 
      *       MOVE ZERO TO IF-PERG1 IF-PERG2 IF-PERM1 IF-PERM2.
      *    IF IF-TPDIC = 2
      *       MOVE ZERO TO IF-PERG1 IF-PERG2 IF-PERM1 IF-PERM2.
      *    IF IF-TPDIC = 3 
      *       MOVE ZERO TO IF-IMPOR.
       E-TPDIC.
      *
       V-IMPOR.
           MOVE 'IF-IMPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPOR.
       E-IMPOR.
      *
       V-PERG1.
           MOVE 'IF-PERG1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERG1.
       E-PERG1.
      *
       V-NPRT2.
           MOVE 'IF-NPRT2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NPRT2.
           IF IF-DICO = 1
              IF IF-NPRT NOT = IF-NPRT2                              
                 MOVE 'E'' possibile selezionare un solo'
                      TO F-MES1
                 MOVE 'protocollo' TO F-MES2
                 MOVE 2 TO F-NMES
                 GO TO V-ERROR.
       E-NPRT2.
      *
       V-PERM1.
           MOVE 'IF-PERM1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERM1.
       E-PERM1.
      *
       V-PERG2.
           MOVE 'IF-PERG2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERG2.
       E-PERG2.
      *
       V-PERM2.
           MOVE 'IF-PERM2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PERM2.
       E-PERM2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *
           MOVE ZERO TO NRECB.
           IF IF-DOGA = 1
              MOVE CODICE3 TO CODICE CODICE2.
           MOVE ZERO      TO TESTA.
      *
           MOVE ZERO      TO RF-RGL.
           MOVE KAZ-COD   TO KRGL-AZI.
           MOVE 'F'       TO KRGL-CF.
           MOVE IF-ANNO   TO KRGL-AARIF.
           MOVE ZERO      TO KRGL-INUIVA SCRITTO. 
           START REGLIN KEY NOT < KEYRGL INVALID GO TO END-RGL-1.
       LOOP-RGL-1.
           READ REGLIN NEXT AT END          GO TO END-RGL-1.
           IF SF-RGL = '9D' OR '9A' OR '35' GO TO LOOP-RGL-1.
           IF KRGL-AZI   NOT = KAZ-COD      GO TO END-RGL-1.
           IF KRGL-CF    NOT = 'F'          GO TO END-RGL-1.
           IF KRGL-AARIF NOT = IF-ANNO      GO TO END-RGL-1.
           IF KRGL-INUIVA > IF-NPRT2        GO TO END-RGL-1.
           IF KRGL-INUIVA < IF-NPRT         GO TO LOOP-RGL-1.
           IF RGL-CLI  < CODICE             GO TO LOOP-RGL-1.
           IF RGL-CLI  > CODICE2            GO TO LOOP-RGL-1.
           IF RGL-FLPRE > ZERO              GO TO LOOP-RGL-1.
      *
           MOVE KRGL-AZI TO KCF-AZI.
           MOVE RGL-CLI  TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID GO TO LOOP-RGL-1.
      *
           IF IF-DOGA = ZERO AND
              CLF-13IVA = 3 GO TO LOOP-RGL-1.
           IF IF-DOGA = 1 GO TO STAMP.
      *    IF CLF-13IVA = 3 GO TO LOOP-RGL-1.
           IF CODICE = CODICE2        GO TO STAMP.
      *    IF CLF-ESEN = ZERO GO TO LOOP-RGL-1.
      *    MOVE 3 TO KTB-TIP.
      *    MOVE CLF-ESEN TO KTB-COD.
      *    READ TABELL INTO REKTAB INVALID GO TO LOOP-RGL-1.
      *    IF T03-TPIVA NOT = 6 GO TO LOOP-RGL-1.
      *
       STAMP.
           IF TESTA = ZERO
              OPEN OUTPUT LETINT
              MOVE 1 TO TESTA
              PERFORM CREA-REC-A THRU EX-REC-A.
           PERFORM CREA-REC-B THRU EX-REC-B.
      *
           MOVE 1       TO RGL-FLPRE.
           MOVE SAV-PRG TO RGL-FPRG.
           MOVE COM-DTIMP TO RGL-DTIMPE.
           REWRITE RF-RGL INVALID CONTINUE.
           MOVE 1 TO SCRITTO.
      *
           GO TO LOOP-RGL-1.
       END-RGL-1.
      *
           IF TESTA NOT = ZERO
              PERFORM CREA-REC-Z THRU EX-REC-Z.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB    INTO REKD02 INVALID GO TO EX-RUN-ELABORA.
      *
           IF SCRITTO = 1
              MOVE SAV-PRG   TO D02-NFILE
              REWRITE RF-DIT FROM REKD02 INVALID GO TO EX-RUN-ELABORA.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       CREA-REC-A.
           MOVE SPACE   TO LETA.
       
           MOVE 'A'     TO LETA-TRA.
           MOVE MODELLO TO LETA-CDF.
      *
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'I'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
      *
           IF D02-CFINT NOT = SPACE 
              MOVE 10 TO LETA-TFO
              MOVE D02-CFINT  TO LETA-CFFO
           ELSE
              MOVE 01 TO LETA-TFO
              MOVE AZI-CFISC  TO LETA-CFFO.
      *
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'B'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
      * 
           MOVE 'A'        TO LETA-VALA.
           MOVE X'0D'      TO LETA-VACR.
           MOVE X'0A'      TO LETA-VALF.
           WRITE RF-LET.
       EX-REC-A.
           EXIT.
      *-----*
       CREA-REC-B.
           MOVE SPACE   TO LETB.
      *
           MOVE ZERO TO LETB-PRMO.
           MOVE ZERO TO LETB-DICO.
           MOVE ZERO TO LETB-PROT1.
           MOVE ZERO TO LETB-PROT2.
           MOVE ZERO TO LETB-PIVA.
           MOVE ZERO TO LETB-DTNA.
           MOVE ZERO TO LETB-CFISCS.
           MOVE ZERO TO LETB-CODC.
           MOVE ZERO TO LETB-DTNAF.
           MOVE ZERO TO LETB-CACQ.
           MOVE ZERO TO LETB-CIMP.
           MOVE ZERO TO LETB-ANNO.
           MOVE ZERO TO LETB-IMPO.
           MOVE ZERO TO LETB-IMPC.
      **** rel 7.2
      *    MOVE ZERO TO LETB-DTDA.
      *    MOVE ZERO TO LETB-DTA.
           MOVE SPACE TO LETB-FILDA.
           MOVE SPACE TO LETB-FILA.
      ************
      **** rel 7.3
      *    MOVE ZERO TO LETB-ANNOD.
      ************
           MOVE ZERO TO LETB-DOGA.
           MOVE ZERO TO LETB-PIVAD.
           MOVE ZERO TO LETB-TPLA.
           MOVE ZERO TO LETB-CDIAP.
           MOVE ZERO TO LETB-EPSO.
           MOVE ZERO TO LETB-CINTRA.
           MOVE ZERO TO LETB-CSANM.
           MOVE ZERO TO LETB-OPERAS.
           MOVE ZERO TO LETB-OPERST.
           MOVE ZERO TO LETB-DTIM.
      *
           MOVE 'B'       TO LETB-TRB.
           MOVE 1         TO LETB-PRMO.
           MOVE AZI-CFISC TO LETB-CFDI.
           MOVE '00343650131' TO LETB-PSWG.
      *--- Integrativa
           MOVE IF-DICO  TO LETB-DICO.
           MOVE IF-PROT1 TO LETB-PROT1.
           MOVE IF-PROT2 TO LETB-PROT2.
      *  Dati del contribuente
           IF AAZ-CGN = SPACE GO TO DENOMA.
           MOVE AAZ-CGN  TO LETB-COGN.
           MOVE AAZ-NOM  TO LETB-NOME.
           MOVE SPACE    TO LETB-DENO.
           MOVE SPACE    TO LETB-SESS.
           IF AAZ-CGN NOT = SPACE
              MOVE AAZ-SES TO LETB-SESS.
           MOVE AAZ-DNA TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO LETB-DTNA.
           MOVE AAZ-CNA  TO LETB-CONA.
           MOVE AAZ-PNA  TO LETB-PRNA.
           GO TO NODENOMA.
       DENOMA.
           MOVE SPACE    TO LETB-COGN.
           MOVE SPACE    TO LETB-NOME.
           MOVE AZRGSOC  TO LETB-DENO.
           MOVE ZERO     TO LETB-DTNA.
           MOVE SPACE    TO LETB-SESS.
       NODENOMA.
           MOVE AZI-PIVA TO LETB-PIVA.
      *--- Dati relativi al rappresentante firmatario della dichiarazion
      *** Dati soggetto tenuto alla comunicazione
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'B'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
           MOVE D02-CFRAP TO LETB-CFISC.
           MOVE D02-CARAP TO LETB-CODC.
      *** Dati soggetto tenuto alla comunicazione(Persona fisica)
           MOVE D02-CORAP TO LETB-CNF.
           MOVE D02-NORAP TO LETB-NOF.
           IF D02-CORAP NOT = SPACE
              MOVE D02-SERAP TO LETB-SEF.
           MOVE D02-DTRAP TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO LETB-DTNAF.
           MOVE D02-CONRAP TO LETB-COFN.
           MOVE D02-PRNRAP TO LETB-PRFN.
           MOVE 02        TO D02-TIP.
           MOVE IF-AZI    TO D02-COD.
           MOVE 'C'       TO D02-PRG.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID 
                MOVE 'Caricare tabella parametri' TO MESS
                GO TO ERRIO.
           MOVE D02-TELRAP TO LETB-NTEL.
           MOVE D02-CFSOC TO LETB-CFISCS.
      *
           IF IF-DOGA =  1
              MOVE 1     TO LETB-CIMP
              MOVE ZERO  TO LETB-CACQ
           ELSE
              MOVE 1     TO LETB-CACQ
              MOVE ZERO  TO LETB-CIMP.
           MOVE IF-ANNO  TO LETB-ANNO.
           MOVE ZERO TO COMIMPO COMIMPC.
           IF RGL-TPDIC = 1
              MOVE RGL-IMPOR  TO COMIMPO
              MOVE ZERO       TO COMIMPC.
           IF RGL-TPDIC = 2
              MOVE ZERO      TO COMIMPO
              MOVE RGL-IMPOR TO COMIMPC.
           MOVE COMIMPO TO LETB-IMPO.
           MOVE COMIMPC TO LETB-IMPC.
      **** rel 7.2
      *    IF RGL-TPDIC = 3
      *       MOVE IF-PERG1 TO GG4
      *       MOVE IF-PERM1 TO MM4
      *       MOVE IF-ANNO  TO AA4
      *       MOVE GGMMAA4  TO LETB-DTDA
      *       MOVE IF-PERG2 TO GG4
      *       MOVE IF-PERM2 TO MM4
      *       MOVE IF-ANNO  TO AA4
      *       MOVE GGMMAA4  TO LETB-DTA.
      ************
           MOVE IF-DESCR-1  TO LETB-DESCR.
      **** rel 7.3
      *    MOVE KRGL-INUIVA TO LETB-NATTR.
      *    MOVE IF-ANNO     TO LETB-ANNOD.
           MOVE SPACE       TO LETB-NATTR.   *> filler
           MOVE SPACE       TO LETB-ANNOD.   *> filler
      ************
      *
           IF IF-DOGA =  1
              MOVE 1     TO LETB-DOGA
           ELSE
              MOVE ZERO  TO LETB-DOGA.
           IF LETB-DOGA = 1
              GO TO NO-DICHIA.
           MOVE RGL-CFISC TO LETB-CFISCD.
      **** rel 7.2
      *    IF CLF-CFISC = SPACE OR
      *       CLF-13IVA = 4 
      *       IF (CLF-CFISC(1:11) NUMERIC AND CLF-CFISC(12:) = SPACE)
      *       OR (CLF-CFISC(16:1) NOT = SPACE)
      *       GO TO NO-MOD
      *    ELSE
      *       MOVE CLF-PIVA TO LETB-CFISCD.
      *NO-MOD.
      *    MOVE CLF-PIVA(1:11) TO LETB-PIVAD.
           MOVE RGL-PIVA(1:11) TO LETB-PIVAD.
      **********
           MOVE RGL-XRGS TO LETB-DENOM.
           MOVE SPACE    TO LETB-COND.
           MOVE SPACE    TO LETB-NOMD.
           MOVE SPACE    TO LETB-SES.
           IF RGL-CGN = SPACE AND
              RGL-NOM = SPACE
              GO TO NO-DICHIA.
           MOVE RGL-CGN  TO LETB-COND.
           MOVE RGL-NOM  TO LETB-NOMD.
           MOVE SPACE    TO LETB-DENOM.
           MOVE RGL-SES  TO LETB-SES.
       NO-DICHIA.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'A'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
           COMPUTE LETB-TPLA = D02-TPLA + 1. 
           MOVE D02-CDIAP  TO  LETB-CDIAP.
           MOVE D02-EPSO   TO  LETB-EPSO.
           MOVE D02-CINTRA TO  LETB-CINTRA.
           MOVE D02-CSANM  TO  LETB-CSANM.
           MOVE D02-OPERAS TO  LETB-OPERAS.
           MOVE D02-OPERST TO  LETB-OPERST.
      *
           MOVE KAZ-COD   TO D02-COD.
           MOVE 'I'       TO D02-PRG.
           MOVE 02        TO D02-TIP.
           MOVE D02-KEYID TO KEYDIT.
           READ LEITAB INTO REKD02 INVALID PERFORM INVK-DIT
                                   GO TO ERRIO.
           MOVE D02-CFINT TO LETB-CFISI.
      **** rel 7.2
      *    MOVE D02-DTIMP TO AAGGG.
           MOVE COM-DTIMP TO AAGGG.
      *********
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA4 TO LETB-DTIM.
           MOVE 1    TO LETB-FIRMA.
           IF LETB-CFISI NOT = SPACE AND
              LETB-CFISI NOT = ZERO
              MOVE 1 TO LETB-FIRMAI
           ELSE
              MOVE 0 TO LETB-FIRMAI.
      *
           MOVE 'A'          TO LETB-VALA.
           MOVE X'0D'        TO LETB-VACR.
           MOVE X'0A'        TO LETB-VALF.
           ADD 1 TO NRECB.
           WRITE RF-LET.
       EX-REC-B.
      *    EXIT.
      *-----*
       CREA-REC-Z.
           MOVE SPACE TO LETZ.
      *    
           MOVE 'Z'   TO LETZ-TRZ.
      *
           MOVE NRECB   TO LETZ-NRTB.
      *
           MOVE 'A'     TO LETZ-VALA.
           MOVE X'0D'   TO LETZ-VACR.
           MOVE X'0A'   TO LETZ-VALF.
           WRITE RF-LET.
      *
       EX-REC-Z.
           EXIT.
      *-----*
