       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGRGL.
      *
      *    Interfaccia PROTOCOLLI LETTERE INTENTO per scheda
      *
      **** rel 7.2
      * nuovo
      **********
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griclfsl'.
           COPY 'griacfsl'.
           COPY 'grirglsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griclf'.
           COPY 'griacf'.
           COPY 'grirgl'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-73'.
           COPY 'gritabrk'.
           COPY 'grit25rk'.
           COPY 'griclfrk'.
           COPY 'parcdt'.
           COPY 'parlk'.
           COPY 'parzf'.
           COPY 'parppar'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-ACF PIC X(15) VALUE 'appclf'.
       01  ID-RGL PIC X(15) VALUE 'reglin'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-ACF  PIC XX.
           05 SF-RGL  PIC XX.
           05 SF-TAB  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(30).
           05 IF-AZI   PIC 9(3).
           05 IF-AARIF PIC 9999.
           05 IF-PRG   PIC 99999.
      **** rel 7.2
           05 COMFLAG  PIC 9.
      ************
           05 IF-CD    PIC 9(5).
           05 CODCLI.
              10 MAS   PIC 99.
              10 COD   PIC 9(5).
       01  PAR-D-RPD.
           05 D-RPD-AZI  PIC 999.
           05 D-RPD-TDES PIC 99.
           05 D-RPD-CDES PIC X(20).
       LINKAGE SECTION.
           COPY 'grirglrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-RGL-CTRL
                                RG-RGL-REC
                                RA-RGL-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclclf'.
           COPY 'dclacf'.
           COPY 'dclrgl'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-RGL-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-RGL-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-RGL-FUN   TO FUN.
           MOVE RG-RGL-IDX   TO IDX.
           MOVE RG-RGL-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-RGL-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgrgl: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-RGL-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-RGL-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-RGL-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK REGLIN.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-RGL INVALID
              PERFORM INVK-RGL
              GO TO ERRIO.
           IF RG-RGL-ATTIVA NOT = ZERO
              PERFORM CAMBIA-FLAG THRU EX-CAMBIA-FLAG.  
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-RGL INVALID
              PERFORM INVK-RGL
              GO TO ERRIO.
           UNLOCK REGLIN.
           IF RG-RGL-ATTIVA NOT = ZERO
              PERFORM CAMBIA-FLAG THRU EX-CAMBIA-FLAG.  
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-RGL
              GO TO WARNING.
           IF RG-RGL-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE REGLIN INVALID
              PERFORM INVK-RGL
              GO TO ERRIO.
           UNLOCK REGLIN.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-RGL-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK REGLIN.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-RGL-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI
                 ANACLF
                 APPCLF
                 REGLIN
                 TABELL.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-RGL-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-RGL-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griclfer'.
           COPY 'griacfer'.
           COPY 'gritaber'.
           COPY 'grirgler'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           IF RG-RGL-FL = ZERO MOVE 'anaazi' TO ID-AZI
                               MOVE 'anaclf' TO ID-CLF
                               MOVE 'tabell' TO ID-TAB
           ELSE                MOVE 'anazol' TO ID-AZI
                               MOVE 'anacfx' TO ID-CLF
                               MOVE 'tabold' TO ID-TAB.
           OPEN INPUT ANAAZI
                      APPCLF.
           OPEN I-O   REGLIN
                      ANACLF
                      TABELL.
      *
           MOVE RG-RGL-AZI TO KAZ-COD.
           READ ANAAZI INVALID
                PERFORM INVK-AZI
                GO TO ERRIO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           IF RG-RGL-CLFO = 'C' MOVE T01-MCLI TO MAS
           ELSE                 MOVE T01-MFOR TO MAS.
      *
           IF RG-RGL-CD = ZERO GO TO ESC-INI-ELABORA.
           MOVE RG-RGL-AZI TO KCF-AZI.
           MOVE RG-RGL-CD  TO COD.
           MOVE CODCLI     TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID PERFORM INVK-CLF
                               GO TO ERRIO.
      *
           MOVE KEYCF TO KEYACF.
           READ APPCLF INVALID MOVE SPACES TO ACF-NAZIO.
      *
       ESC-INI-ELABORA.
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-RGL-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO  TO RF-RGL.
           MOVE SPACES TO RGL-RGSOC RGL-RGSOC2 RGL-INDIR
                          RGL-INDIR2 RGL-CIT
                          RGL-PRV RGL-PIVA.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
           MOVE RG-RGL-AZI TO IF-AZI.
           MOVE RG-RGL-CD  TO IF-CD.
           MOVE RG-RGL-AARIF TO IF-AARIF.
           MOVE RG-RGL-PRG   TO IF-PRG.
      * azzeramento aree interfaccia
           MOVE ZERO  TO RG-RGL-REC.
           MOVE ZERO  TO RA-RGL-AGG.
           MOVE SPACES TO RG-RGL-RGSOC RG-RGL-RGSOC2 RG-RGL-INDIR
                          RG-RGL-INDIR2 RG-RGL-CIT
                          RG-RGL-PRV RG-RGL-PIVA RG-RGL-NOM RG-RGL-CGN
                          RG-RGL-CFISC.
           MOVE 'M' TO RG-RGL-SES.
      * ripristino dei campi chiave fissi
           MOVE IF-AZI TO RG-RGL-AZI.
           MOVE IF-CD  TO RG-RGL-CD.
           MOVE IF-AARIF TO RG-RGL-AARIF.
           MOVE IF-PRG   TO RG-RGL-PRG.
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE RG-RGL-AZI TO KRGL-AZI.
           MOVE RG-RGL-AARIF TO KRGL-AARIF.
           MOVE RG-RGL-CLFO  TO KRGL-CF.
           MOVE ZERO TO RG-RGL-CD.
           MOVE 2 TO RGL-TPDIC RG-RGL-TPDIC.
      *
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
       RD1-TB25C.
           READ TABELL INTO REKT25 KEPT LOCK INVALID
              PERFORM INVK-TAB
              GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35'
                             PERFORM REC-LOCK
                             GO TO RD1-TB25C.
           IF RG-RGL-CLFO = 'C'
             MOVE T25-PRTC TO RG-RGL-PRG
           ELSE
             MOVE T25-PRT TO RG-RGL-PRG.
           ADD 1 TO RG-RGL-PRG.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9    TO AAGGG.
           MOVE AA9    TO GG9.
           MOVE AAGGG  TO AA9.
           COMPUTE RG-RGL-AARIF = 2000 + AA9.
           MOVE RG-RGL-AARIF TO KRGL-AARIF.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
           IF RG-RGL-CLFO = 'C'
             IF RG-RGL-PRG NOT > T25-PRTC GO TO INS-OK-90
             END-IF
             MOVE RG-RGL-PRG TO T25-PRTC
           ELSE
             IF RG-RGL-PRG NOT > T25-PRT GO TO INS-OK-90
             END-IF
             MOVE RG-RGL-PRG TO T25-PRT.
           REWRITE RF-TAB FROM REKT25 INVALID
                          PERFORM INVK-TAB
                          GO TO ERRIO.
       INS-OK-90.
           UNLOCK TABELL.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
           MOVE 25      TO T25-TIP.
           MOVE KAZ-COD TO T25-COD.
           MOVE '1' TO T25-PRG.
           MOVE T25-KEYID TO KEYTB.
       RD2-TB25D.
           READ TABELL INTO REKT25 KEPT LOCK INVALID
                                             PERFORM INVK-TAB
                                             GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35'
                             PERFORM REC-LOCK
                             GO TO RD2-TB25D.
           IF RG-RGL-CLFO = 'C'
             IF RG-RGL-PRG NOT = T25-PRTC GO TO ULCKT
             END-IF
             SUBTRACT 1 FROM T25-PRTC
           ELSE
             IF RG-RGL-PRG NOT = T25-PRT GO TO ULCKT
             END-IF
             SUBTRACT 1 FROM T25-PRT.
           REWRITE RF-TAB FROM REKT25 INVALID
                          PERFORM INVK-TAB
                          GO TO ERRIO.
       ULCKT.
           UNLOCK TABELL.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-RGL-AZI   TO KRGL-AZI.
           MOVE RG-RGL-CLFO  TO KRGL-CF.
           MOVE RG-RGL-AARIF TO KRGL-AARIF.
           MOVE RG-RGL-PRG   TO KRGL-INUIVA.
           MOVE KEYRGL TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYRGL.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ REGLIN INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ REGLIN KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-RGL > ZERO MOVE 7 TO RG-RGL-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYRGL TO KRIFER.
       SET-10.
           READ REGLIN NEXT AT END GO TO SET-90.
           IF KEYRGL = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'VRGRGL: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                   TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ REGLIN PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ REGLIN NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-RGL = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
           IF KRGL-AZI NOT = RG-RGL-AZI  GO TO RNP-10.
           IF RGL-CLI  NOT = CODCLI      GO TO RNP-10.
      * trovato record valido: reset EOF
           MOVE ZERO TO RG-RGL-EOF.
           MOVE KEYRGL TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-RGL-EOF.
           IF RG-RGL-EOF = 4 MOVE 2 TO RG-RGL-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-RGL = LOW-VALUE GO TO EX-TEST-EOL.
           IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KRGL-AZI = RG-RGL-AZI AND
              RGL-CLI  = CODCLI  GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-RGL-AZI TO KRGL-AZI.
           MOVE RG-RGL-PRG TO KRGL-INUIVA.
           MOVE RG-RGL-AARIF TO KRGL-AARIF.
           MOVE RG-RGL-CLFO TO KRGL-CF.
           MOVE CODCLI TO RGL-CLI.
           MOVE RG-RGL-RGSOC TO RGL-RGSOC.
           MOVE RG-RGL-RGSOC2 TO RGL-RGSOC2.
           MOVE RG-RGL-INDIR TO RGL-INDIR.
           MOVE RG-RGL-INDIR2 TO RGL-INDIR2.
           MOVE RG-RGL-CAP  TO RGL-CAP.
           MOVE RG-RGL-CIT TO RGL-CIT.
           MOVE RG-RGL-PRV TO RGL-PRV.
           MOVE RG-RGL-PIVA  TO RGL-PIVA.
           MOVE RG-RGL-DTIVAI  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RGL-DTIVAI.
           MOVE RG-RGL-DTIVAF  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RGL-DTIVAF.
           MOVE RG-RGL-DTIVAR  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RGL-DTIVAR.
           MOVE RG-RGL-DTIMPE  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RGL-DTIMPE.
           MOVE RG-RGL-IDPROT1  TO RGL-PROT1.
           MOVE RG-RGL-IDPROT2  TO RGL-PROT2.
           MOVE RG-RGL-DTIMPEC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO RGL-DTIMPEC.
           MOVE RG-RGL-PRGC  TO RGL-PRGC.
           MOVE RG-RGL-TPDIC TO RGL-TPDIC.
           MOVE RG-RGL-IMPOR TO RGL-IMPOR.
           MOVE RG-RGL-FLPRE TO RGL-FLPRE.
           MOVE RG-RGL-FPRG  TO RGL-FPRG.
           MOVE RG-RGL-ATTIVA TO RGL-ATTIVA.
      *
           MOVE RG-RGL-DTATT  TO GGMMAA.
           MOVE 1             TO TIPOP1.
           CALL 'rdata'    USING PARCDT.
           MOVE AAGGG         TO RGL-DTATT.
           MOVE RG-RGL-NOM    TO RGL-NOM.
           MOVE RG-RGL-CGN    TO RGL-CGN.
           MOVE RG-RGL-CFISC  TO RGL-CFISC.
           MOVE RG-RGL-SES    TO RGL-SES.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KRGL-AZI TO RG-RGL-AZI.
           MOVE KRGL-INUIVA TO RG-RGL-PRG.
           MOVE KRGL-AARIF TO RG-RGL-AARIF.
           MOVE RGL-CLI TO CODCLI.
           MOVE RGL-RGSOC TO RG-RGL-RGSOC.
           MOVE RGL-RGSOC2 TO RG-RGL-RGSOC2.
           MOVE RGL-INDIR TO RG-RGL-INDIR.
           MOVE RGL-INDIR2 TO RG-RGL-INDIR2.
           MOVE RGL-NOM    TO RG-RGL-NOM.
           MOVE RGL-CGN    TO RG-RGL-CGN.
           MOVE RGL-CFISC  TO RG-RGL-CFISC.
           MOVE RGL-SES    TO RG-RGL-SES.
           MOVE RGL-CAP  TO RG-RGL-CAP.
           MOVE RGL-CIT TO RG-RGL-CIT.
           MOVE RGL-PRV TO RG-RGL-PRV.
           MOVE RGL-PIVA  TO RG-RGL-PIVA.
           MOVE RGL-DTIVAI  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RGL-DTIVAI.
           MOVE RGL-DTIVAF  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RGL-DTIVAF.
           MOVE RGL-DTIVAR  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RGL-DTIVAR.
           MOVE RGL-DTIMPE  TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RGL-DTIMPE.
           MOVE RGL-PROT1  TO RG-RGL-IDPROT1.
           MOVE RGL-PROT2  TO RG-RGL-IDPROT2.
           MOVE RGL-DTIMPEC TO AAGGG.
           MOVE 2 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA TO RG-RGL-DTIMPEC.
           MOVE RGL-PRGC  TO RG-RGL-PRGC.
           MOVE RGL-TPDIC TO RG-RGL-TPDIC.
           MOVE RGL-IMPOR TO RG-RGL-IMPOR.
           MOVE RGL-FLPRE TO RG-RGL-FLPRE.
           MOVE RGL-FPRG  TO RG-RGL-FPRG.
           MOVE RGL-ATTIVA TO RG-RGL-ATTIVA.
           MOVE RGL-DTATT  TO AAGGG.
           MOVE 2          TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE GGMMAA     TO RG-RGL-DTATT.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           EVALUATE RGL-TPDIC
             WHEN 1 MOVE 'Singola Operazione' TO RA-RGL-TPDIC-D
             WHEN 2 MOVE 'Per un importo    ' TO RA-RGL-TPDIC-D
             WHEN OTHER MOVE 'Per un periodo' TO RA-RGL-TPDIC-D
           END-EVALUATE.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-RGL-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-AARIF.
           MOVE 'RGL-AARIF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-AARIF.
           IF RG-RGL-AARIF = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-AARIF.
      *
       V-COD.
           MOVE 'RGL-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-COD.
           IF RG-RGL-PRG = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-COD.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-RGL-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
       V-CODCF.
           MOVE 'RGL-CODCF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CODCF.
           IF RG-RGL-CD = ZERO
             PERFORM ERR-ZERO
             GO TO V-ERROR.
           MOVE RG-RGL-AZI TO KCF-AZI.
           MOVE RG-RGL-CD  TO COD.
           MOVE CODCLI     TO KCF-COD.
           IF RGL-CLI NOT = ZERO AND = CODCLI GO TO E-CODCF.
           READ ANACLF INTO REKCLF INVALID PERFORM ERR-CINE
                               GO TO V-ERROR.
      *
           MOVE KEYCF TO KEYACF.
           READ APPCLF INVALID MOVE SPACES TO ACF-NAZIO.
           MOVE RG-RGL-AZI TO KRGL-AZI.
           MOVE RG-RGL-AARIF TO KRGL-AARIF.
           MOVE RG-RGL-CLFO  TO KRGL-CF.
           MOVE KCF-COD   TO RGL-CLI.
           MOVE CLF-XRGS  TO RGL-XRGS.
           MOVE CLF-XIND  TO RGL-XIND.
           MOVE CLF-CAP   TO RGL-CAP RG-RGL-CAP.
           MOVE CLF-CITTA TO RGL-CITTA.
           MOVE CLF-PIVA  TO RGL-PIVA RG-RGL-PIVA.
           MOVE CLF-CFISC TO RGL-CFISC RG-RGL-CFISC.
           IF CLF-CFISC = SPACE OR
              CLF-13IVA = 4 
              IF (CLF-CFISC(1:11) NUMERIC AND CLF-CFISC(12:) = SPACE)
              OR (CLF-CFISC(16:1) NOT = SPACE)
              GO TO NO-MOD
           ELSE
              MOVE CLF-PIVA TO RGL-CFISC RG-RGL-CFISC.
        NO-MOD.
           MOVE RGL-RGSOC TO RG-RGL-RGSOC.
           MOVE RGL-RGSOC2 TO RG-RGL-RGSOC2.
           MOVE RGL-INDIR TO RG-RGL-INDIR.
           MOVE RGL-INDIR2 TO RG-RGL-INDIR2.
           MOVE RGL-CIT TO RG-RGL-CIT.
           MOVE RGL-PRV TO RG-RGL-PRV.
       E-CODCF.
      *
       V-RGSOC.
           MOVE 'RGL-RGSOC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-RGSOC.
           IF RG-RGL-RGSOC = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-RGSOC.
      *
       V-INDIR.
           MOVE 'RGL-INDIR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-INDIR.
           IF RG-RGL-INDIR = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-INDIR.
      *
       V-CAP.
           MOVE 'RGL-CAP' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAP.
           IF FUN = 'V' GO TO E-CAP. *> solo x 'W'
      *
           MOVE 40 TO T40-TIP.
           MOVE ACF-NAZIO TO T40-COD.
           MOVE T40-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID KEY GO TO E-CAP.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           IF RG-RGL-CAP = ZERO 
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CAP.
      *
       V-CIT.
           MOVE 'RGL-CIT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CIT.
           IF RG-RGL-CIT = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CIT.
      *
       V-PRV.
           MOVE 'RGL-PRV' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PRV.
           IF FUN = 'V' GO TO E-PRV. *> solo x 'W'
      *
           MOVE 40 TO T40-TIP.
           MOVE ACF-NAZIO TO T40-COD.
           MOVE T40-KEYID TO KEYTB.
           READ TABELL INTO REKTAB INVALID KEY GO TO E-PRV.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
      *
           IF RG-RGL-PRV = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PRV.
      *
       V-DTIVAI.
           MOVE 'RGL-DTIVAI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIVAI.
           IF RG-RGL-TPDIC NOT = 3 GO TO E-DTIVAI.
           IF RG-RGL-DTIVAI = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RGL-DTIVAI TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTIVAI.
      *
       V-DTIVAF.
           MOVE 'RGL-DTIVAF' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIVAF.
           IF RG-RGL-TPDIC NOT = 3 GO TO E-DTIVAF.
           IF RG-RGL-DTIVAF = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RGL-DTIVAF TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTIVAF.
      *
       V-DTIVAR.
           MOVE 'RGL-DTIVAR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIVAR.
           IF RG-RGL-TPDIC NOT = 3 GO TO E-DTIVAR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RGL-DTIVAR TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTIVAR.
      *
       V-DTIMPE.
           MOVE 'RGL-DTIMPE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIMPE.
           IF RG-RGL-DTIMPE = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RGL-DTIMPE TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTIMPE.
      *
       V-DTATT.
           MOVE 'RGL-DTATT' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTATT.
      *    IF RG-RGL-ATTIVA > ZERO
      *    IF RG-RGL-DTATT = ZERO
      *       PERFORM ERR-ZERO
      *       GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RGL-DTATT TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTATT.
       V-PRGC.
           IF RG-RGL-CLFO NOT = 'C' GO TO E-PRGC.
           MOVE 'RGL-PRGC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-PRGC.
           IF RG-RGL-PRGC = ZERO
      **** rel 7.3
              IF RG-RGL-DTIMPEC = ZERO
                 GO TO E-PRGC
              ELSE
      ************
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-PRGC.
      *
       V-DTIMPEC.
           IF RG-RGL-CLFO NOT = 'C' GO TO E-DTIMPEC.
           MOVE 'RGL-DTIMPEC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DTIMPEC.
           IF RG-RGL-DTIMPEC = ZERO
      **** rel 7.3
              IF RG-RGL-PRGC = ZERO
                 GO TO E-DTIMPEC
              ELSE
      ************
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1 TO TIPOP1.
           MOVE RG-RGL-DTIMPEC TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
       E-DTIMPEC.
      *
       V-TPDIC.
           MOVE 'RGL-TPDIC' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TPDIC.
           IF RG-RGL-TPDIC = 3
              MOVE ZERO TO RG-RGL-IMPOR.
           IF RG-RGL-TPDIC = 1 OR 2 
              MOVE ZERO TO RG-RGL-DTIVAI RG-RGL-DTIVAF.
           EVALUATE RG-RGL-TPDIC
             WHEN 1 MOVE 'Singola Operazione' TO RA-RGL-TPDIC-D
             WHEN 2 MOVE 'Per un importo    ' TO RA-RGL-TPDIC-D
             WHEN OTHER MOVE 'Per un periodo' TO RA-RGL-TPDIC-D
           END-EVALUATE.
       E-TPDIC.
      *
       V-IMPOR.
           MOVE 'RGL-IMPOR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-IMPOR.
           IF RG-RGL-TPDIC = 3 GO TO E-IMPOR.
           IF RG-RGL-IMPOR = ZERO
              PERFORM ERR-ZERO 
              GO TO V-ERROR.
       E-IMPOR.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------
       CAMBIA-FLAG.
      *
           MOVE RG-RGL-CD  TO COD.
      *
           MOVE LOW-VALUE  TO KEYRGL.
           MOVE RG-RGL-AZI TO KRGL-AZI.
           MOVE CODCLI  TO RGL-CLI.
           MOVE ZERO       TO KRGL-AARIF.
           MOVE ZERO       TO KRGL-INUIVA.
           START REGLIN KEY NOT < SKEYRGL3 INVALID GO TO END-RGL.
       LOOP-RGL.
           READ REGLIN NEXT AT END GO TO END-RGL.
           IF SF-RGL = '9D' OR '9A' OR '35' GO TO LOOP-RGL.
           IF KRGL-AZI  > RG-RGL-AZI GO TO END-RGL.
           IF RGL-CLI   > CODCLI  GO TO END-RGL.
           IF KRGL-AARIF  = RG-RGL-AARIF AND
              KRGL-INUIVA = RG-RGL-PRG
              GO TO LOOP-RGL.
      *
           MOVE ZERO TO RGL-ATTIVA.
           REWRITE RF-RGL.
      *
           GO TO LOOP-RGL.
       END-RGL.
      *
           MOVE RG-RGL-AZI TO KCF-AZI.
           MOVE RG-RGL-CD  TO COD.
           MOVE CODCLI     TO KCF-COD.
           READ ANACLF  INTO REKCLF INVALID GO TO EX-CAMBIA-FLAG.
      *
           MOVE RG-RGL-PRG     TO CLF-INUIVA.
           MOVE RG-RGL-DTIMPE  TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG          TO  CLF-IDTIVA.
      *
           MOVE RG-RGL-PRGC    TO  CLF-ENUIVA.
           MOVE RG-RGL-DTIMPEC TO GGMMAA.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG          TO CLF-EDTIVA.
           REWRITE RF-CLF FROM REKCLF.
       EX-CAMBIA-FLAG.
           EXIT.
      *--------------------------------------------
